/* ali.h */

#define MAX_NUM_NAMES    500
#define GAPC     '-'

typedef struct {
  int i;        /* i,j in [0, n-1] */
  int j;
  int rank;
  float p;      /* probability */
  float ent;    /* pseudo entropy for p(i,j) = S_i + S_j - p_ij*ln(p_ij) */
  int bp[8];    /* frequencies of pair_types */
  /* char sym;  */   /* 1 iff (i.j) and (j.i) predicted */
  int comp;    /* 1 iff compatible with all bp with higher score */
}  pair_info;

typedef struct {
  int i,j,len;  /* (i.j) closing, pair, length len */
  int best;     /* index of highest ranked pair in stack */
  int n_comp;   /* compensatory mutations */
  int n_bad;    /* incompatible bases */
  int layer;
} stack;

typedef struct {
  int want_quiet, want_verbose;
  int p;
  int lfold;
  int compf;
  float pfrali_cw;
  float covar_nc;
  float covar_beta;
  float pmin;
  int ncmax;
  int mountain;
  char ext[16];
  FILE *INFILE;
  int layers;
} alidot_options;



extern int read_clustal(FILE *clust, char *AlignedSeqs[], char *names[]);
extern void print_pi(pair_info pi);
extern char *get_line(FILE *fp);
extern void nrerror(char *message);
#ifdef WITH_DMALLOC
#include "dmalloc.h"
#define space(S) calloc(1,(S))
#else
extern void *space(unsigned size);
extern void  *xrealloc(void *p, unsigned size);
#endif
extern short *make_pair_table(const char *structure);

/* End of file */
